Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/OptiPngFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/OptiPngFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/OptiPngFilter.php	(revision 7265)
@@ -0,0 +1,75 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Exception\FilterException;
+use Symfony\Component\Process\ProcessBuilder;
+
+/**
+ * Runs assets through OptiPNG.
+ *
+ * @link   http://optipng.sourceforge.net/
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class OptiPngFilter implements FilterInterface
+{
+    private $optipngBin;
+    private $level;
+
+    /**
+     * Constructor.
+     *
+     * @param string $optipngBin Path to the optipng binary
+     */
+    public function __construct($optipngBin = '/usr/bin/optipng')
+    {
+        $this->optipngBin = $optipngBin;
+    }
+
+    public function setLevel($level)
+    {
+        $this->level = $level;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+        $pb = new ProcessBuilder(array($this->optipngBin));
+
+        if (null !== $this->level) {
+            $pb->add('-o')->add($this->level);
+        }
+
+        $pb->add('-out')->add($output = tempnam(sys_get_temp_dir(), 'assetic_optipng'));
+        unlink($output);
+
+        $pb->add($input = tempnam(sys_get_temp_dir(), 'assetic_optipng'));
+        file_put_contents($input, $asset->getContent());
+
+        $proc = $pb->getProcess();
+        $code = $proc->run();
+
+        if (0 < $code) {
+            unlink($input);
+            throw FilterException::fromProcess($proc)->setInput($asset->getContent());
+        }
+
+        $asset->setContent(file_get_contents($output));
+
+        unlink($input);
+        unlink($output);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HashableInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HashableInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HashableInterface.php	(revision 7265)
@@ -0,0 +1,27 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+/**
+ * A filter can implement a hash function
+ *
+ * @author Francisco Facioni <fran6co@gmail.com>
+ */
+interface HashableInterface
+{
+    /**
+     * Generates a hash for the object
+     *
+     * @return string Object hash
+     */
+    public function hash();
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssImportFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssImportFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssImportFilter.php	(revision 7265)
@@ -0,0 +1,106 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Asset\FileAsset;
+use Assetic\Asset\HttpAsset;
+
+/**
+ * Inlines imported stylesheets.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CssImportFilter extends BaseCssFilter
+{
+    private $importFilter;
+
+    /**
+     * Constructor.
+     *
+     * @param FilterInterface $importFilter Filter for each imported asset
+     */
+    public function __construct(FilterInterface $importFilter = null)
+    {
+        $this->importFilter = $importFilter ?: new CssRewriteFilter();
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        $importFilter = $this->importFilter;
+        $sourceRoot = $asset->getSourceRoot();
+        $sourcePath = $asset->getSourcePath();
+
+        $callback = function($matches) use ($importFilter, $sourceRoot, $sourcePath) {
+            if (!$matches['url'] || null === $sourceRoot) {
+                return $matches[0];
+            }
+
+            $importRoot = $sourceRoot;
+
+            if (false !== strpos($matches['url'], '://')) {
+                // absolute
+                list($importScheme, $tmp) = explode('://', $matches['url'], 2);
+                list($importHost, $importPath) = explode('/', $tmp, 2);
+                $importRoot = $importScheme.'://'.$importHost;
+            } elseif (0 === strpos($matches['url'], '//')) {
+                // protocol-relative
+                list($importHost, $importPath) = explode('/', substr($matches['url'], 2), 2);
+                $importHost = '//'.$importHost;
+            } elseif ('/' == $matches['url'][0]) {
+                // root-relative
+                $importPath = substr($matches['url'], 1);
+            } elseif (null !== $sourcePath) {
+                // document-relative
+                $importPath = $matches['url'];
+                if ('.' != $sourceDir = dirname($sourcePath)) {
+                    $importPath = $sourceDir.'/'.$importPath;
+                }
+            } else {
+                return $matches[0];
+            }
+
+            // ignore other imports
+            if ('css' != pathinfo($importPath, PATHINFO_EXTENSION)) {
+                return $matches[0];
+            }
+
+            $importSource = $importRoot.'/'.$importPath;
+            if (false !== strpos($importSource, '://') || 0 === strpos($importSource, '//')) {
+                $import = new HttpAsset($importSource, array($importFilter), true);
+            } elseif (!file_exists($importSource)) {
+                // ignore not found imports
+                return $matches[0];
+            } else {
+                $import = new FileAsset($importSource, array($importFilter), $importRoot, $importPath);
+            }
+
+            $import->setTargetPath($sourcePath);
+
+            return $import->dump();
+        };
+
+        $content = $asset->getContent();
+        $lastHash = md5($content);
+
+        do {
+            $content = $this->filterImports($content, $callback);
+            $hash = md5($content);
+        } while ($lastHash != $hash && $lastHash = $hash);
+
+        $asset->setContent($content);
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/ScssphpFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/ScssphpFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/ScssphpFilter.php	(revision 7265)
@@ -0,0 +1,58 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Loads SCSS files using the PHP implementation of scss, scssphp.
+ *
+ * Scss files are mostly compatible, but there are slight differences.
+ *
+ * @link http://leafo.net/scssphp/
+ *
+ * @author Bart van den Burg <bart@samson-it.nl>
+ */
+class ScssphpFilter implements FilterInterface
+{
+    private $compass = false;
+
+    public function enableCompass($enable = true)
+    {
+        $this->compass = (Boolean) $enable;
+    }
+
+    public function isCompassEnabled()
+    {
+        return $this->compass;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        $root = $asset->getSourceRoot();
+        $path = $asset->getSourcePath();
+
+        $lc = new \scssc();
+        if ($this->compass) {
+            new \scss_compass($lc);
+        }
+        if ($root && $path) {
+            $lc->addImportPath(dirname($root.'/'.$path));
+        }
+
+        $asset->setContent($lc->compile($asset->getContent()));
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssRewriteFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssRewriteFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssRewriteFilter.php	(revision 7265)
@@ -0,0 +1,102 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Fixes relative CSS urls.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CssRewriteFilter extends BaseCssFilter
+{
+    public function filterLoad(AssetInterface $asset)
+    {
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+        $sourceBase = $asset->getSourceRoot();
+        $sourcePath = $asset->getSourcePath();
+        $targetPath = $asset->getTargetPath();
+
+        if (null === $sourcePath || null === $targetPath || $sourcePath == $targetPath) {
+            return;
+        }
+
+        // learn how to get from the target back to the source
+        if (false !== strpos($sourceBase, '://')) {
+            list($scheme, $url) = explode('://', $sourceBase.'/'.$sourcePath, 2);
+            list($host, $path) = explode('/', $url, 2);
+
+            $host = $scheme.'://'.$host.'/';
+            $path = false === strpos($path, '/') ? '' : dirname($path);
+            $path .= '/';
+        } else {
+            // assume source and target are on the same host
+            $host = '';
+
+            // pop entries off the target until it fits in the source
+            if ('.' == dirname($sourcePath)) {
+                $path = str_repeat('../', substr_count($targetPath, '/'));
+            } elseif ('.' == $targetDir = dirname($targetPath)) {
+                $path = dirname($sourcePath).'/';
+            } else {
+                $path = '';
+                while (0 !== strpos($sourcePath, $targetDir)) {
+                    if (false !== $pos = strrpos($targetDir, '/')) {
+                        $targetDir = substr($targetDir, 0, $pos);
+                        $path .= '../';
+                    } else {
+                        $targetDir = '';
+                        $path .= '../';
+                        break;
+                    }
+                }
+                $path .= ltrim(substr(dirname($sourcePath).'/', strlen($targetDir)), '/');
+            }
+        }
+
+        $content = $this->filterReferences($asset->getContent(), function($matches) use ($host, $path) {
+            if (false !== strpos($matches['url'], '://') || 0 === strpos($matches['url'], '//') || 0 === strpos($matches['url'], 'data:')) {
+                // absolute or protocol-relative or data uri
+                return $matches[0];
+            }
+
+            if ('/' == $matches['url'][0]) {
+                // root relative
+                return str_replace($matches['url'], $host.$matches['url'], $matches[0]);
+            }
+
+            // document relative
+            $url = $matches['url'];
+            while (0 === strpos($url, '../') && 2 <= substr_count($path, '/')) {
+                $path = substr($path, 0, strrpos(rtrim($path, '/'), '/') + 1);
+                $url = substr($url, 3);
+            }
+
+            $parts = array();
+            foreach (explode('/', $host.$path.$url) as $part) {
+                if ('..' === $part && count($parts) && '..' !== end($parts)) {
+                    array_pop($parts);
+                } else {
+                    $parts[] = $part;
+                }
+            }
+
+            return str_replace($matches['url'], implode('/', $parts), $matches[0]);
+        });
+
+        $asset->setContent($content);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/FilterCollection.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/FilterCollection.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/FilterCollection.php	(revision 7265)
@@ -0,0 +1,82 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * A collection of filters.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class FilterCollection implements FilterInterface, \IteratorAggregate, \Countable
+{
+    private $filters = array();
+
+    public function __construct($filters = array())
+    {
+        foreach ($filters as $filter) {
+            $this->ensure($filter);
+        }
+    }
+
+    /**
+     * Checks that the current collection contains the supplied filter.
+     *
+     * If the supplied filter is another filter collection, each of its
+     * filters will be checked.
+     */
+    public function ensure(FilterInterface $filter)
+    {
+        if ($filter instanceof \Traversable) {
+            foreach ($filter as $f) {
+                $this->ensure($f);
+            }
+        } elseif (!in_array($filter, $this->filters, true)) {
+            $this->filters[] = $filter;
+        }
+    }
+
+    public function all()
+    {
+        return $this->filters;
+    }
+
+    public function clear()
+    {
+        $this->filters = array();
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        foreach ($this->filters as $filter) {
+            $filter->filterLoad($asset);
+        }
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+        foreach ($this->filters as $filter) {
+            $filter->filterDump($asset);
+        }
+    }
+
+    public function getIterator()
+    {
+        return new \ArrayIterator($this->filters);
+    }
+
+    public function count()
+    {
+        return count($this->filters);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssMinFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssMinFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/CssMinFilter.php	(revision 7265)
@@ -0,0 +1,74 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Filters assets through CssMin.
+ *
+ * @link http://code.google.com/p/cssmin
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CssMinFilter implements FilterInterface
+{
+    private $filters;
+    private $plugins;
+
+    public function __construct()
+    {
+        $this->filters = array();
+        $this->plugins = array();
+    }
+
+    public function setFilters(array $filters)
+    {
+        $this->filters = $filters;
+    }
+
+    public function setFilter($name, $value)
+    {
+        $this->filters[$name] = $value;
+    }
+
+    public function setPlugins(array $plugins)
+    {
+        $this->plugins = $plugins;
+    }
+
+    public function setPlugin($name, $value)
+    {
+        $this->plugins[$name] = $value;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+        $filters = $this->filters;
+        $plugins = $this->plugins;
+
+        if (isset($filters['ImportImports']) && true === $filters['ImportImports']) {
+            $root = $asset->getSourceRoot();
+            $path = $asset->getSourcePath();
+            if ($root && $path) {
+                $filters['ImportImports'] = array('BasePath' => dirname($root.'/'.$path));
+            } else {
+                unset($filters['ImportImports']);
+            }
+        }
+
+        $asset->setContent(\CssMin::minify($asset->getContent(), $filters, $plugins));
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/PhpCssEmbedFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/PhpCssEmbedFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/PhpCssEmbedFilter.php	(revision 7265)
@@ -0,0 +1,48 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use CssEmbed\CssEmbed;
+use Assetic\Asset\AssetInterface;
+
+/**
+ * A filter that embed url directly into css
+ *
+ * @author Pierre Tachoire <pierre.tachoire@gmail.com>
+ * @link https://github.com/krichprollsch/phpCssEmbed
+ */
+class PhpCssEmbedFilter implements FilterInterface
+{
+    private $presets = array();
+
+    public function setPresets(array $presets)
+    {
+        $this->presets = $presets;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        $root = $asset->getSourceRoot();
+        $path = $asset->getSourcePath();
+
+        $pce = new CssEmbed();
+        if ($root && $path) {
+            $pce->setRootDir(dirname($root.'/'.$path));
+        }
+
+        $asset->setContent($pce->embedString($asset->getContent()));
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/JpegoptimFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/JpegoptimFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/JpegoptimFilter.php	(revision 7265)
@@ -0,0 +1,81 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Exception\FilterException;
+use Symfony\Component\Process\ProcessBuilder;
+
+/**
+ * Runs assets through Jpegoptim.
+ *
+ * @link   http://www.kokkonen.net/tjko/projects.html
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class JpegoptimFilter implements FilterInterface
+{
+    private $jpegoptimBin;
+    private $stripAll;
+    private $max;
+
+    /**
+     * Constructor.
+     *
+     * @param string $jpegoptimBin Path to the jpegoptim binary
+     */
+    public function __construct($jpegoptimBin = '/usr/bin/jpegoptim')
+    {
+        $this->jpegoptimBin = $jpegoptimBin;
+    }
+
+    public function setStripAll($stripAll)
+    {
+        $this->stripAll = $stripAll;
+    }
+
+    public function setMax($max)
+    {
+        $this->max = $max;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+        $pb = new ProcessBuilder(array($this->jpegoptimBin));
+
+        if ($this->stripAll) {
+            $pb->add('--strip-all');
+        }
+
+        if ($this->max) {
+            $pb->add('--max='.$this->max);
+        }
+
+        $pb->add($input = tempnam(sys_get_temp_dir(), 'assetic_jpegoptim'));
+        file_put_contents($input, $asset->getContent());
+
+        $proc = $pb->getProcess();
+        $proc->run();
+
+        if (false !== strpos($proc->getOutput(), 'ERROR')) {
+            unlink($input);
+            throw FilterException::fromProcess($proc)->setInput($asset->getContent());
+        }
+
+        $asset->setContent(file_get_contents($input));
+
+        unlink($input);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HandlebarsFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HandlebarsFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/HandlebarsFilter.php	(revision 7265)
@@ -0,0 +1,109 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Exception\FilterException;
+use Symfony\Component\Process\ProcessBuilder;
+
+/**
+ * Compiles Handlebars templates into Javascript.
+ *
+ * @link http://handlebarsjs.com/
+ * @author Keyvan Akbary <keyvan@funddy.com>
+ */
+class HandlebarsFilter implements FilterInterface
+{
+    private $handlebarsPath;
+    private $nodePath;
+
+    private $minimize = false;
+    private $simple = false;
+
+    public function __construct($handlebarsPath = '/usr/bin/handlebars', $nodePath = null)
+    {
+        $this->handlebarsPath = $handlebarsPath;
+        $this->nodePath = $nodePath;
+    }
+
+    public function setMinimize($minimize)
+    {
+        $this->minimize = $minimize;
+    }
+
+    public function setSimple($simple)
+    {
+        $this->simple = $simple;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        $executables = array();
+
+        if ($this->nodePath !== null) {
+            $executables[] = $this->nodePath;
+        }
+
+        $executables[] = $this->handlebarsPath;
+
+        $processBuilder = new ProcessBuilder($executables);
+
+        $templateName = basename($asset->getSourcePath());
+
+        $inputDirPath = sys_get_temp_dir().DIRECTORY_SEPARATOR.uniqid('input_dir');
+        $inputPath = $inputDirPath.DIRECTORY_SEPARATOR.$templateName;
+        $outputPath = tempnam(sys_get_temp_dir(), 'output');
+
+        mkdir($inputDirPath);
+        file_put_contents($inputPath, $asset->getContent());
+
+        $processBuilder->add($inputPath)->add('-f')->add($outputPath);
+
+        if ($this->minimize) {
+            $processBuilder->add('--min');
+        }
+
+        if ($this->simple) {
+            $processBuilder->add('--simple');
+        }
+
+        $process = $processBuilder->getProcess();
+        $returnCode = $process->run();
+
+        unlink($inputPath);
+        rmdir($inputDirPath);
+
+        if (127 === $returnCode) {
+            throw new \RuntimeException('Path to node executable could not be resolved.');
+        }
+
+        if (0 < $returnCode) {
+            if (file_exists($outputPath)) {
+                unlink($outputPath);
+            }
+            throw FilterException::fromProcess($process)->setInput($asset->getContent());
+        }
+
+        if (!file_exists($outputPath)) {
+            throw new \RuntimeException('Error creating output file.');
+        }
+
+        $compiledJs = file_get_contents($outputPath);
+        unlink($outputPath);
+
+        $asset->setContent($compiledJs);
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/StylusFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/StylusFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/StylusFilter.php	(revision 7265)
@@ -0,0 +1,117 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Exception\FilterException;
+use Symfony\Component\Process\ProcessBuilder;
+
+/**
+ * Loads STYL files.
+ *
+ * @link http://learnboost.github.com/stylus/
+ * @author Konstantin Kudryashov <ever.zet@gmail.com>
+ */
+class StylusFilter implements FilterInterface
+{
+    private $nodeBin;
+    private $nodePaths;
+    private $compress;
+
+    /**
+     * Constructs filter.
+     *
+     * @param string $nodeBin   The path to the node binary
+     * @param array  $nodePaths An array of node paths
+     */
+    public function __construct($nodeBin = '/usr/bin/node', array $nodePaths = array())
+    {
+        $this->nodeBin = $nodeBin;
+        $this->nodePaths = $nodePaths;
+    }
+
+    /**
+     * Enable output compression.
+     *
+     * @param boolean $compress
+     */
+    public function setCompress($compress)
+    {
+        $this->compress = $compress;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function filterLoad(AssetInterface $asset)
+    {
+        static $format = <<<'EOF'
+var stylus = require('stylus');
+var sys    = require(process.binding('natives').util ? 'util' : 'sys');
+
+stylus(%s, %s).render(function(e, css){
+    if (e) {
+        throw e;
+    }
+
+    sys.print(css);
+    process.exit(0);
+});
+
+EOF;
+
+        $root = $asset->getSourceRoot();
+        $path = $asset->getSourcePath();
+
+        // parser options
+        $parserOptions = array();
+        if ($root && $path) {
+            $parserOptions['paths'] = array(dirname($root.'/'.$path));
+            $parserOptions['filename'] = basename($path);
+        }
+
+        if (null !== $this->compress) {
+            $parserOptions['compress'] = $this->compress;
+        }
+
+        $pb = new ProcessBuilder();
+        $pb->inheritEnvironmentVariables();
+
+        // node.js configuration
+        if (0 < count($this->nodePaths)) {
+            $pb->setEnv('NODE_PATH', implode(':', $this->nodePaths));
+        }
+
+        $pb->add($this->nodeBin)->add($input = tempnam(sys_get_temp_dir(), 'assetic_stylus'));
+        file_put_contents($input, sprintf($format,
+            json_encode($asset->getContent()),
+            json_encode($parserOptions)
+        ));
+
+        $proc = $pb->getProcess();
+        $code = $proc->run();
+        unlink($input);
+
+        if (0 < $code) {
+            throw FilterException::fromProcess($proc)->setInput($asset->getContent());
+        }
+
+        $asset->setContent($proc->getOutput());
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/LessFilter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/LessFilter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Filter/LessFilter.php	(revision 7265)
@@ -0,0 +1,136 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Filter;
+
+use Assetic\Asset\AssetInterface;
+use Assetic\Exception\FilterException;
+use Symfony\Component\Process\ProcessBuilder;
+
+/**
+ * Loads LESS files.
+ *
+ * @link http://lesscss.org/
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class LessFilter implements FilterInterface
+{
+    private $nodeBin;
+    private $nodePaths;
+    private $compress;
+
+    /**
+     * Load Paths
+     *
+     * A list of paths which less will search for includes.
+     * 
+     * @var array
+     */
+    protected $loadPaths = array();
+
+    /**
+     * Constructor.
+     *
+     * @param string $nodeBin   The path to the node binary
+     * @param array  $nodePaths An array of node paths
+     */
+    public function __construct($nodeBin = '/usr/bin/node', array $nodePaths = array())
+    {
+        $this->nodeBin = $nodeBin;
+        $this->nodePaths = $nodePaths;
+    }
+
+    public function setCompress($compress)
+    {
+        $this->compress = $compress;
+    }
+
+    /**
+     * Adds a path where less will search for includes
+     * 
+     * @param string $path Load path (absolute)
+     */
+    public function addLoadPath($path)
+    {
+        $this->loadPaths[] = $path;
+    }
+
+    public function filterLoad(AssetInterface $asset)
+    {
+        static $format = <<<'EOF'
+var less = require('less');
+var sys  = require(process.binding('natives').util ? 'util' : 'sys');
+
+new(less.Parser)(%s).parse(%s, function(e, tree) {
+    if (e) {
+        less.writeError(e);
+        process.exit(2);
+    }
+
+    try {
+        sys.print(tree.toCSS(%s));
+    } catch (e) {
+        less.writeError(e);
+        process.exit(3);
+    }
+});
+
+EOF;
+
+        $root = $asset->getSourceRoot();
+        $path = $asset->getSourcePath();
+
+        // parser options
+        $parserOptions = array();
+        if ($root && $path) {
+            $parserOptions['paths'] = array(dirname($root.'/'.$path));
+            $parserOptions['filename'] = basename($path);
+        }
+        foreach ($this->loadPaths as $loadPath) {
+            $parserOptions['paths'][] = $loadPath;
+        }
+
+        // tree options
+        $treeOptions = array();
+        if (null !== $this->compress) {
+            $treeOptions['compress'] = $this->compress;
+        }
+
+        $pb = new ProcessBuilder();
+        $pb->inheritEnvironmentVariables();
+
+        // node.js configuration
+        if (0 < count($this->nodePaths)) {
+            $pb->setEnv('NODE_PATH', implode(':', $this->nodePaths));
+        }
+
+        $pb->add($this->nodeBin)->add($input = tempnam(sys_get_temp_dir(), 'assetic_less'));
+        file_put_contents($input, sprintf($format,
+            json_encode($parserOptions),
+            json_encode($asset->getContent()),
+            json_encode($treeOptions)
+        ));
+
+        $proc = $pb->getProcess();
+        $code = $proc->run();
+        unlink($input);
+
+        if (0 < $code) {
+            throw FilterException::fromProcess($proc)->setInput($asset->getContent());
+        }
+
+        $asset->setContent($proc->getOutput());
+    }
+
+    public function filterDump(AssetInterface $asset)
+    {
+    }
+}
